Do not show "History" tab for content in Filesystem repository

2022-08-19 03:16 - Go MAEDA

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: SCM Estimated time: 0.00 hour

Target version: 5.0.3   

Resolution: Fixed Affected version:  

Description

Although Filesystem repository (#1393) does not support revisions, "History" tab is shown for content in a Filesystem repository.

Another tab, "Annotate", which is not available in a Filesystem repository, is hidden. "History" tab should also be hidden.
Related issues:

Related to Redmine - Patch #37657: Rename Repository#supports_all_revisions? ... Closed

Associated revisions

Revision 21800 - 2022-09-07 07:47 - Go MAEDA

Don't show "History" tab for content in Filesystem repository (#37585).

Patch by Go MAEDA.

Revision 21802 - 2022-09-09 08:54 - Go MAEDA

Merged r21800 from trunk to 5.0-stable (#37585).

History

#1 - 2022-08-19 05:23 - Mischa The Evil

Go MAEDA wrote:

[...] "History" tab should also be hidden.

I agree. I think this can be solved by adding:

a Repository#supports_history? method that would return 'true';

a Repository::Filesystem#supports_history? method that would return 'false';

a condition (if @repository.supports_history?) in source:/app/views/repositories/_link_to_functions.html.erb@21772#L11 for the rendering of the

history tab.

What do you think?

#2 - 2022-08-19 11:57 - Go MAEDA

Mischa The Evil wrote:

Go MAEDA wrote:

I agree. I think this can be solved by adding:

a Repository#supports_history? method that would return 'true';

a Repository::Filesystem#supports_history? method that would return 'false';

a condition (if @repository.supports_history?) in source:/app/views/repositories/_link_to_functions.html.erb@21772#L11 for the rendering

of the history tab.

 Can we use the existing Repository#supports_all_revisions? instead of adding a new method?

#3 - 2022-08-20 05:36 - Mischa The Evil

Go MAEDA wrote:

2025-07-11 1/3

https://www.redmine.org/issues/1393
https://www.redmine.org/projects/redmine/repository/svn/revisions/21772/entry/app/views/repositories/_link_to_functions.html.erb#L11
https://www.redmine.org/projects/redmine/repository/svn/revisions/21772/entry/app/views/repositories/_link_to_functions.html.erb#L11


Can we use the existing Repository#supports_all_revisions? instead of adding a new method?

 I've taken a closer look at Repository#supports_all_revisions? and I think we can indeed. However, I think that the name of that method combined

with what it's used for, can be quite confusing (which is also what led me to my previous proposal). I'll elaborate.

Repository#supports_all_revisions? was introduced in r5143 in support of r5145, as such was its original purpose to use it to make a distinction for

rendering either the "view all revisions" or the "view revisions" link.

Following its introduction Etienne opened #7984, for which several changes were applied. And, while that issue remains open until today, I think it is

actually solved with the commits that are related to the issue, but left open because of the additional (IMHO out-of-scope) matters that came up with it

(see #7984#note-22 and #7984#note-23).

Nowadays Repository#supports_all_revisions? is additionally used for:

the statistics link condition;

the revision text field tag condition;

the atom links condition.

Given the above, we now already have four uses for the method and with the proposal for this issue, it'll make five.

The problem with this isn't the usage itself. Instead, I think it's the name of the method which can be confusing in itself and as such be problematic.

TL;DR: I think that Repository#supports_all_revisions? can be used as-is for a new condition to hide the history tab in a 5.0.x maintenance release.

For 5.1.x (or 6.x) though, I'd say it might be more accurate to rename the method to Repository#supports_history?.

What do you think?

#4 - 2022-09-03 17:02 - Go MAEDA

- File 37585.patch added

- Target version set to Candidate for next minor release

Mischa The Evil wrote:

TL;DR: I think that Repository#supports_all_revisions? can be used as-is for a new condition to hide the history tab in a 5.0.x maintenance

release.

For 5.1.x (or 6.x) though, I'd say it might be more accurate to rename the method to Repository#supports_history?.

 I agree, naming is important. I will commit the attached patch for 5.0.3. After that, I will open a new issue that suggests changing the name of the

method from supports_all_revisions? to supports_history?.

#5 - 2022-09-05 14:59 - Go MAEDA

- Target version changed from Candidate for next minor release to 5.0.3

Setting the target version to 5.0.3.

#6 - 2022-09-07 07:47 - Go MAEDA

- Status changed from New to Resolved

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch.

#7 - 2022-09-09 08:54 - Go MAEDA

- Related to Patch #37657: Rename Repository#supports_all_revisions? to Repository#supports_history? added

#8 - 2022-09-09 08:55 - Go MAEDA

Mischa The Evil wrote:

TL;DR: I think that Repository#supports_all_revisions? can be used as-is for a new condition to hide the history tab in a 5.0.x maintenance

release.

For 5.1.x (or 6.x) though, I'd say it might be more accurate to rename the method to Repository#supports_history?.

 I have opened #37657.

#9 - 2022-09-09 08:56 - Go MAEDA

2025-07-11 2/3

https://www.redmine.org/projects/redmine/repository/svn/revisions/5143
https://www.redmine.org/projects/redmine/repository/svn/revisions/5145
https://www.redmine.org/issues/7984
https://www.redmine.org/issues/7984#note-22
https://www.redmine.org/issues/7984#note-23
https://www.redmine.org/issues/37657


- Status changed from Resolved to Closed

Files
37585.patch 1.95 KB 2022-09-03 Go MAEDA
